import { EditorType, SingleOrMultiple } from ".";
import { EditorButton, EditorGroup } from "./Editors";
import { EditorInputBase } from "./Editors/EditorInputBase";
export declare class Editor {
    private readonly root;
    private readonly themeSelect;
    private currentTheme?;
    private readonly _themes;
    get data(): unknown;
    constructor(id: string, name: string, data: unknown);
    addButton(name: string, label: string, autoMap?: boolean): EditorButton;
    addGroup(name: string, title: string, collapsed?: boolean, customParent?: unknown): EditorGroup;
    addProperty(name: string, label: string, type: EditorType, value?: SingleOrMultiple<unknown>, autoMap?: boolean): EditorInputBase;
    top(): Editor;
    bottom(): Editor;
    left(): Editor;
    right(): Editor;
    theme(theme: string): void;
    addTheme(theme: string): void;
    themes(): Iterable<string>;
    protected customize(): void;
}
