import { EditorItem } from "./EditorItem";
import { EditorButton } from "./EditorButton";
import { SingleOrMultiple } from "../Types";
import { EditorInputBase } from "./EditorInputBase";
import { EditorType } from "../Enums";
export declare class EditorGroup extends EditorItem {
    readonly name: string;
    private readonly title;
    readonly children: EditorItem[];
    private readonly childrenGroup;
    private readonly collapseButton;
    private constructor();
    static createRoot(name: string, title: string, data: unknown, parent: HTMLElement, themeSelect: HTMLSelectElement): EditorGroup;
    addGroup(name: string, title: string, collapsed?: boolean, customParent?: unknown): EditorGroup;
    addProperty(name: string, label: string, type: EditorType, value?: SingleOrMultiple<unknown>, autoMap?: boolean): EditorInputBase;
    addButton(name: string, label: string, autoMap?: boolean): EditorButton;
    toggleCollapse(): void;
    updateCollapse(collapsed: boolean): void;
    private setCollapse;
}
